function turnLeft() {
    if ("south" == actorDirection) {
        actorDirection = "east";
        actorImageSrc = "./images/karel_right.png";
    } else if ("east" == actorDirection) {
        actorDirection = "north";
        actorImageSrc = "./images/karel_top.png";
    } else if ("north" == actorDirection) {
        actorDirection = "west";
        actorImageSrc = "./images/karel_left.png";
    } else {
        actorDirection = "south";
        actorImageSrc = "./images/karel_bottom.png";
    }
    drawBasicTerritory();
    drawTerritoryContent();
    actorImage.src = actorImageSrc;
}

function turnRight() {
    if ("south" == actorDirection) {
        actorDirection = "west";
        actorImageSrc = "./images/karel_left.png";
    } else if ("east" == actorDirection) {
        actorDirection = "south";
        actorImageSrc = "./images/karel_bottom.png";
    } else if ("north" == actorDirection) {
        actorDirection = "east";
        actorImageSrc = "./images/karel_right.png";
    } else {
        actorDirection = "north";
        actorImageSrc = "./images/karel_top.png";
    }
    drawBasicTerritory();
    drawTerritoryContent();
    actorImage.src = actorImageSrc;
}

function turnAround() {
    if ("south" == actorDirection) {
        actorDirection = "north";
        actorImageSrc = "./images/karel_top.png";
    } else if ("east" == actorDirection) {
        actorDirection = "west";
        actorImageSrc = "./images/karel_left.png";
    } else if ("north" == actorDirection) {
        actorDirection = "south";
        actorImageSrc = "./images/karel_bottom.png";
    } else {
        actorDirection = "east";
        actorImageSrc = "./images/karel_right.png";
    }
    drawBasicTerritory();
    drawTerritoryContent();
    actorImage.src = actorImageSrc;
}

function moveForward() {
    if (frontIsClear()) {
        territoryContent[actorRow][actorColumn].setActor(false);
        if ("south" == actorDirection) {
            actorRow = (actorRow + 1) % row;
            currentY = actorRow * cellHeight + 25;
        } else if ("east" == actorDirection) {
            actorColumn = (actorColumn + 1) % column;
            currentX = actorColumn * cellWidth + 30;
        } else if ("north" == actorDirection) {
            actorRow = (actorRow + row - 1) % row;
            currentY = actorRow * cellHeight + 25;
        } else {
            actorColumn = (actorColumn + column - 1) % column;
            currentX = actorColumn * cellWidth + 30;
        }
        territoryContent[actorRow][actorColumn].setActor(true);
        drawBasicTerritory();
        drawTerritoryContent();
        drawActor();
    } else {
        window.alert("Karel kann nicht gegen eine Wand laufen.");
        stopCode();
    }
}

function pickBeeper() {
    if (onBeeper()) {
        territoryContent[actorRow][actorColumn].decrementItem();
        drawBasicTerritory();
        drawTerritoryContent();
        drawActor();
    } else {
        window.alert("Auf diesem Feld liegt kein Beeper.");
        stopCode();
    }
}

function dropBeeper() {
    if (onBeeper()) {
        window.alert("Auf diesem Feld liegt bereits ein Beeper.");
        stopCode();
    } else {
        currentDraggableToCanvas = "itemImage";
        var x = cellWidth * actorColumn + (cellWidth / 2);
        var y = cellHeight * actorRow + (cellHeight / 2);
        var position = [x, y];
        setCellContent(actorRow, actorColumn, position, [0, 0]);
    }
}

function onBeeper() {
    return territoryContent[actorRow][actorColumn].getItem();
}

function itemAmount() {
    return territoryContent[actorRow][actorColumn].getItemAmount();
}

function hasItem() {
    if (karelItems > 0) {
        return true;
    } else {
        return false;
    }
}


function beeperAhead() {
    if (!frontIsClear()) {
        return false;
    }
    var result = true;
    if ("south" == actorDirection) {
        result = territoryContent[actorRow + 1][actorColumn].getItem();
    } else if ("east" == actorDirection) {
        result = territoryContent[actorRow][actorColumn + 1].getItem();
    } else if ("north" == actorDirection) {
        result = territoryContent[actorRow - 1][actorColumn].getItem();
    } else if ("west" == actorDirection) {
        result = territoryContent[actorRow][actorColumn - 1].getItem();
    }
    console.log("result beeperAhead: ", !result);
    return result;
}

function frontIsClear() {
    if ("south" == actorDirection) {
        return actorRow + 1 < row && !territoryContent[actorRow][actorColumn].getSouthWall();
    } else if ("east" == actorDirection) {
        return actorColumn + 1 < column && !territoryContent[actorRow][actorColumn].getEastWall();
    } else if ("north" == actorDirection) {
        return actorRow > 0 && !territoryContent[actorRow][actorColumn].getNorthWall();
    } else if ("west" == actorDirection) {
        return actorColumn > 0 && !territoryContent[actorRow][actorColumn].getWestWall();
    }
    return false;
}

function leftIsClear() {
    if ("west" == actorDirection) {
        return actorRow + 1 < row && !territoryContent[actorRow][actorColumn].getSouthWall();
    } else if ("south" == actorDirection) {
        return actorColumn + 1 < column && !territoryContent[actorRow][actorColumn].getEastWall();
    } else if ("east" == actorDirection) {
        return actorRow > 0 && !territoryContent[actorRow][actorColumn].getNorthWall();
    } else if ("north" == actorDirection) {
        return actorColumn > 0 && !territoryContent[actorRow][actorColumn].getWestWall();
    }
    return false;
}

function rightIsClear() {
    if ("east" == actorDirection) {
        return actorRow + 1 < row && !territoryContent[actorRow][actorColumn].getSouthWall();
    } else if ("north" == actorDirection) {
        return actorColumn + 1 < column && !territoryContent[actorRow][actorColumn].getEastWall();
    } else if ("west" == actorDirection) {
        return actorRow > 0 && !territoryContent[actorRow][actorColumn].getNorthWall();
    } else if ("south" == actorDirection) {
        return actorColumn > 0 && !territoryContent[actorRow][actorColumn].getWestWall();
    }
    return false;
}
